import { jsx as _jsx } from "hastscript/jsx-runtime";
/**
 * The default renderers for {@link renderToHast}
 *
 * @internal
 */
export const defaultRenderOptions = {
    pre({ style, children, meta }) {
        return meta.title ? (_jsx("div", { children: _jsx("pre", { style: style, dataCodeTitle: meta.title, children: children }) })) : (_jsx("pre", { style: style, children: children }));
    },
    code({ children, meta }) {
        const { lang, showLineNumbers } = meta;
        return _jsx("code", { dataLanguage: lang, dataLineNumbers: showLineNumbers, children: children });
    },
    line({ children, meta, index }) {
        const { lineNumbers, lineNumbersStart } = meta;
        const lineNumber = index + lineNumbersStart;
        const highlighted = (lineNumbers === null || lineNumbers === void 0 ? void 0 : lineNumbers.includes(index)) ? true : null;
        return (_jsx("span", { dataHighlighted: highlighted, dataLineNumber: lineNumber, children: children }));
    },
    token({ style, children }) {
        return _jsx("span", { style: style, children: children });
    },
};
//# sourceMappingURL=default-render-options.js.map